import java.util.*;
public class Skill{
	private String name;
	private int ranks,highSkill,totalSkills;
	private Ability ability;
	private ArrayList<Subskill> subskills;
	private CCGUI parent;
	
	public Skill(String n, Ability a,CCGUI t){
		name=n;
		ranks=0;
		subskills=new ArrayList<Subskill>();
		ability=a;
		highSkill=0;
		totalSkills=0;
		parent=t;}
		
	public String getName(){return name;}
	
	public int getRanks(){
		int temp = ranks + highSkill;
		if(!parent.isHighestSkill())
			if(totalSkills>0)
				temp+=2*(totalSkills-1);
		return temp;
	}
	
	public void changeRanks(int r,boolean f){
		if(f){
			if(highSkill<r)
				highSkill=r;
			totalSkills++;
		}
		else
			ranks+=r;
	}
	
	//unused; here just in case you need it
	public void setRanks(int r){ranks=r;}
	
	public Ability getAbility(){return ability;}
	
//a=subskill, b=ranks
	public void addSubskill(String a, int b, boolean d){
		for(int x=0; x<subskills.size(); x++){
			if(subskills.get(x).getName().equals(a)){
				subskills.get(x).changeRanks(b,d);
				return;
			}
		}
		Subskill temp=new Subskill(a,ability,this,parent);
		temp.changeRanks(b,d);
		subskills.add(temp);
	}
	
	public String toString(){
		String a= getName()+": "+Utility.toD6(getRanks()+ability.getRanks())+"\n";
		for(int x=0; x<subskills.size(); x++){
			a+="    "+subskills.get(x).toString()+"\n";}
		return a;}
	}